Attribute VB_Name = "DirectX7Sound"
Option Explicit

Private m_dx As New DirectX7
Private m_dxs As DirectSound
Private SB() As dxBuffers
Private CurrentBuffer As Integer

Type dxBuffers
    isLoaded As Boolean
    Buffer As DirectSoundBuffer
End Type

Public Sub CreateBuffers(AmountOfBuffer As Integer, DefaultSample As String)
  ReDim SB(AmountOfBuffer)
  For AmountOfBuffer = 0 To AmountOfBuffer
    DX7LoadSound AmountOfBuffer, DefaultSample
  Next AmountOfBuffer
End Sub

Public Sub SetFormForDX7Sound(Form As Form)
    Set m_dxs = m_dx.DirectSoundCreate("")
    If Err.Number <> 0 Then
        MsgBox "Unable to start DirectSound. Please check the following:" + vbNewLine + " - Your sound card is properly installed." + vbNewLine + " - DirectX 7 is installed on your system.", vbCritical + vbOKOnly, "DirectSound"
        End
    End If
    m_dxs.SetCooperativeLevel Form.hwnd, DSSCL_PRIORITY
End Sub

Public Sub DX7LoadSound(Buffer As Integer, sfile As String)
    Dim Filename As String
    Dim bufferDesc As DSBUFFERDESC
    Dim waveFormat As WAVEFORMATEX
    bufferDesc.lFlags = DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME Or DSBCAPS_STATIC
    waveFormat.nFormatTag = WAVE_FORMAT_PCM
    waveFormat.nChannels = 2
    waveFormat.lSamplesPerSec = 22050
    waveFormat.nBitsPerSample = 16
    waveFormat.nBlockAlign = waveFormat.nBitsPerSample / 8 * waveFormat.nChannels
    waveFormat.lAvgBytesPerSec = waveFormat.lSamplesPerSec * waveFormat.nBlockAlign
    'Sample = sfile
    'Set SB(Buffer).Buffer = m_dxs.CreateSoundBufferFromFile(Sample, bufferDesc, waveFormat)
    'SB(Buffer).isLoaded = True
    Exit Sub
End Sub

Public Function PlaySoundAnyBuffer(Filename As String, Optional Volume As Byte, Optional PanValue As Byte, Optional LoopIt As Byte) As Integer
    Do While SB(CurrentBuffer).Buffer.GetStatus = DSBSTATUS_PLAYING
        CurrentBuffer = CurrentBuffer + 1
        If CurrentBuffer > UBound(SB) Then CurrentBuffer = 0
    Loop
    DX7LoadSound CurrentBuffer, Filename
    If SB(CurrentBuffer).isLoaded Then SB(CurrentBuffer).Buffer.Play LoopIt
End Function

Public Function IsPlaying(Buffer As Integer) As Long
  IsPlaying = SB(Buffer).Buffer.GetStatus
End Function


