Attribute VB_Name = "MMC"
Option Explicit

DefLng A-Z

Public CurrVr As Byte
Public PrgSwitch1 As Byte
Public PrgSwitch2 As Byte
Public SpecialWrite6000 As Boolean
Public bank0(2047) As Byte
Public bank6(8191) As Byte
Public bank8(8191) As Byte
Public bankA(8191) As Byte
Public bankC(8191) As Byte
Public bankE(8191) As Byte
Private pval8 As Long
Private pval4(1) As Long
Private pval2(3) As Long
Private pval1(7) As Long
Public pTablesWritten As Boolean

Public Sub MMC3_Sync()
    If swap Then
        reg8 = &HFE
        regA = PrgSwitch2
        regC = PrgSwitch1
        regE = &HFF
    Else
        reg8 = PrgSwitch1
        regA = PrgSwitch2
        regC = &HFE
        regE = &HFF
    End If
    SetupBanks
End Sub

Public Function MaskBankAddress(bank As Byte)
    Dim i As Byte: i = &HFF
    Do While ((bank And i) >= (PrgCount * 2))
        i = i \ 2
    Loop
    MaskBankAddress = (bank And i)
End Function

Public Function MaskVROM(page As Byte, mask As Byte) As Byte
    MaskVROM = (page And (mask - 1))
End Function

Public Sub SetupBanks()
    reg8 = MaskBankAddress(reg8)
    regA = MaskBankAddress(regA)
    regC = MaskBankAddress(regC)
    regE = MaskBankAddress(regE)
    MemCopy bank8(0), gameImage(reg8 * &H2000&), &H2000&
    MemCopy bankA(0), gameImage(regA * &H2000&), &H2000&
    MemCopy bankC(0), gameImage(regC * &H2000&), &H2000&
    MemCopy bankE(0), gameImage(regE * &H2000&), &H2000&
End Sub

Private Sub dirty8()
    pval8 = 0
End Sub

Private Sub dirty4()
    pval4(0) = 0
    pval4(1) = 0
End Sub

Private Sub dirty2()
    pval2(0) = 0
    pval2(1) = 0
    pval2(2) = 0
    pval2(3) = 0
End Sub

Private Sub dirty1()
    Dim i As Long
    For i = 0 To 7
        pval1(i) = 0
    Next i
End Sub

Public Sub Select8KVROM(val1 As Byte)
    If pTablesWritten Then
        pTablesWritten = False
        dirty8
    End If
    val1 = MaskVROM(val1, ChrCount)
    If val1 + 1 <> pval8 Then
        MemCopy VRAM(0), VROM(val1 * &H2000&), &H2000&
        pval8 = val1 + 1
        dirty1
        dirty2
        dirty4
    End If
End Sub

Public Sub Select4KVROM(val1 As Byte, bank As Byte)
    If pTablesWritten Then
        pTablesWritten = False
        dirty1
        dirty2
        dirty4
    End If
    val1 = MaskVROM(val1, ChrCount * 2)
    If val1 + 1 <> pval4(bank) Then
        MemCopy VRAM(bank * &H1000&), VROM(val1 * &H1000&), &H1000&
        pval4(bank) = val1 + 1
        pval8 = 0
        pval2(bank * 2) = 0
        pval2(bank * 2 + 1) = 0
        pval1(bank * 4) = 0
        pval1(bank * 4 + 1) = 0
        pval1(bank * 4 + 2) = 0
        pval1(bank * 4 + 3) = 0
    End If
End Sub

Public Sub Select2KVROM(val1 As Byte, bank As Byte)
    If pTablesWritten Then
        pTablesWritten = False
        dirty1
        dirty2
        dirty4
        dirty8
    End If
    val1 = MaskVROM(val1, ChrCount * 4)
    If val1 + 1 <> pval2(bank) Then
        If Mapper = 4 Then
            MemCopy VRAM(MMC3_ChrAddr Xor (bank * &H800&)), VROM(val1 * &H800&), &H800&
        Else
            MemCopy VRAM(bank * &H800&), VROM(val1 * &H800&), &H800&
        End If
        pval2(bank) = val1 + 1
        pval8 = 0
        pval4(bank \ 2) = 0
        pval1(bank * 2) = 0
        pval1(bank * 2 + 1) = 0
    End If
End Sub

Public Sub Select1KVROM(val1 As Byte, bank As Byte)
    If pTablesWritten Then
        pTablesWritten = False
        dirty1
        dirty2
        dirty4
        dirty8
    End If
    val1 = MaskVROM(val1, ChrCount * 8)
    If val1 + 1 <> pval1(bank) Then
        If Mapper = 4 Then
            MemCopy VRAM(MMC3_ChrAddr Xor (bank * &H400&)), VROM(val1 * &H400&), &H400&
        Else
            MemCopy VRAM(bank * &H400&), VROM(val1 * &H400&), &H400&
        End If
        pval1(bank) = val1 + 1
        pval2(bank \ 2) = 0
        pval4(bank \ 4) = 0
        pval8 = 0
    End If
End Sub
